# Metadata

``` json
{
    "id" : "string"
    "name" : "string"
    "short description" : "string"
    "description" : "string"
    "logo" : "string"
    "creator" : "peer_id"
    "owner(s)" {
        "name" : "string"
        "logo" : "string"
    }

    "instances":
    [
        {
            "location" : "geo coord"
            "country" : "string"
            "url" : "string"
            allowed_groups : peers_group
            <specific data> see below
        }
    ]
}
```


## Common
* locations: location list

## Data

* personal_data: bool
* anonymized_personal_data: bool
* type: string
* license
* open_data: bool
* quality: string

## ComputeUnit
* infrastructure : Kubernetes, Docker, HW, Slurm, Condor
* architecture : X86_64
* access_protocol : enum(KubeAPI(https) [over SSH],  DirectSSH, Slurm  [over SSH], Docker [over SSH], over Opencloud, over VPN) or string
* security_level: Secnumcloud, HDS, ... Gaia1/2/3...
* countries
* investors: 
* power_source:
* usage_restrictions: string

## Processing

* url: string
* type: container, exe
* license: string
* open_source: bool 
* marutity: (stable, alpha,...)


## Storage 

* type: File, S3, Database
* url: string
* access_protocol : enum(KubeAPI(https) [over SSH],  DirectSSH, Slurm  [over SSH], Docker [over SSH], over Opencloud, over VPN) or string
* security_level: Secnumcloud, HDS, ... Gaia1/2/3...
* country:
* investors: 
* usage_restrictions: string